<?php
namespace um_ext\um_profile_completeness\core;

if ( ! defined( 'ABSPATH' ) ) exit;

class Profile_Completeness_Admin {

	function __construct() {
	
		$this->slug = 'ultimatemember';
		$this->pagehook = 'toplevel_page_ultimatemember';
		
		add_action('admin_enqueue_scripts',  array(&$this, 'admin_enqueue_scripts'), 9);

        add_filter( 'um_settings_structure', array( &$this, 'profile_completeness_settings' ) , 10, 1 );

	}

	/***
	***	@admin styles
	***/
	function admin_enqueue_scripts() {
		
		wp_register_style('um_admin_profile_completeness', um_profile_completeness_url . 'assets/css/um-admin-profile-completeness.css' );
		wp_enqueue_style('um_admin_profile_completeness');
		
		wp_register_script('um_admin_profile_completeness', um_profile_completeness_url . 'assets/js/um-admin-profile-completeness.js', '', '', true );
		wp_enqueue_script('um_admin_profile_completeness');
		
	}


    function profile_completeness_settings( $settings ) {
        $settings['licenses']['fields'][] = array(
            'id'      		=> 'um_profile_completeness_license_key',
            'label'    		=> __( 'Profile Completeness License Key', 'um-profile-completeness' ),
            'item_name'     => 'Profile Completeness',
            'author' 	    => 'Ultimate Member',
            'version' 	    => um_profile_completeness_version,
        );

        return $settings;
    }

}