<?php
namespace um_ext\um_reviews\core;

if ( ! defined( 'ABSPATH' ) ) exit;

class Reviews_Enqueue {

	/**
	 * Reviews_Enqueue constructor.
	 */
	function __construct() {
		add_action( 'wp_enqueue_scripts',  array( &$this, 'wp_enqueue_scripts' ), 0 );
        add_filter( 'um_enqueue_localize_data',  array( &$this, 'localize_data' ), 10, 1 );
	}


	/**
	 * Enqueue scripts/styles
	 */
	function wp_enqueue_scripts() {
		wp_register_style( 'um_reviews', um_reviews_url . 'assets/css/um-reviews.css' );
		wp_enqueue_style( 'um_reviews' );
		
		wp_register_script( 'um_reviews', um_reviews_url . 'assets/js/um-reviews.js', '', '', true );
		wp_enqueue_script( 'um_reviews' );
		
		// Localize the script with new data
		$translation_array = array(
			'add_rating'                => __( 'Please add a rating.', 'um-reviews' ),
			'provide_title'             => __( 'You must provide a title.', 'um-reviews' ),
			'provide_review_content'    => __( 'You must provide review content.', 'um-reviews' ),
			'remove'                    => __( 'Remove', 'um-reviews' ),
			'cancel'                    => __( 'Cancel', 'um-reviews' ),
			'star'                      => __( 'Star', 'um-reviews' ),
		);
		wp_localize_script( 'um_reviews', 'um_reviews', $translation_array );
	}


	/**
	 * @param $data
	 *
	 * @return mixed
	 */
	function localize_data( $data ) {

		$data['review_trash']   = UM()->get_ajax_route( 'um_ext\um_reviews\core\Reviews_Main_API', 'ajax_review_trash' );
		$data['review_flag']    = UM()->get_ajax_route( 'um_ext\um_reviews\core\Reviews_Main_API', 'ajax_review_flag' );
		$data['review_add'] = UM()->get_ajax_route( 'um_ext\um_reviews\core\Reviews_Main_API', 'ajax_review_add' );

		return $data;
	}

}